<?php

namespace App\Http\Controllers;

use App\Repositories\Interfaces\commonRepositoriesInterface;
use App\Repositories\Interfaces\employeeRepositoriesInterface;
use Session;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Hash;
use Illuminate\Http\Request;
use GuzzleHttp\Client;

use App\Http\Requests;
class EmployeeController extends Controller
{
    private  $employeeRepository;
    private  $commonRepository;
    
    public function __construct(employeeRepositoriesInterface $employeeRepository,commonRepositoriesInterface $commonRepository) 
    {

        $this->employeeRepository = $employeeRepository;
        $this->commonRepository = $commonRepository;
    }

   function saveEmployee(Request $request) ///:JsonResponse
   {

   	  $validator = Validator::make($request->all(), [
            'EnrollNumber' => 'required',
           
            'Name' => 'required',
            'email' => 'required|email|unique:users',
            'password' => 'required'
            
       ]);

       

        $user = array(

          'enrol_id' =>$request->EnrollNumber,
          'name' =>$request->Name,
          
          'email' =>$request->email,
          'password' =>  Hash::make($request->get('password')),
          'role' =>  'employee',
         

        );
          $column = array('id');
          $where = array(
            'enrol_id' =>$request->EnrollNumber
          );
          $data = $this->commonRepository->selectRow("users",$column,$where);
           $data = json_decode(json_encode($data), true);
          if (empty($data)) {
              if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("users",$user)

             
            ],
            Response::HTTP_CREATED
        );

       
       }
          }else{
            return response()->json(
            [
                'status'=>FALSE,
                'data' => "This Enrol ID Already In"
            ],
            Response::HTTP_CREATED

            );
          }

      

        
   }


  function allEmployee(Request $Request):JsonResponse
  {   
  	    $column = array('enrol_id','name','id');
    
  	      $data = $this->commonRepository->selectRows("users",$column,array());
  	      
             return response()->json(
            [
                'status'=>TRUE,
                'data' =>  $data
            ],
            Response::HTTP_CREATED
        );
  }


  function EmployeeDatatable(Request $request)
  {
       $columarray = array(
        'id',
        'enrol_id',
       'name',
       'email',
       
       'password',
       'shift_id',
       'join_date',
       'designation_id',
       'department_id',
       'manger_id',
       'first_name',
       'last_name',
       'father_name',
       'dob',
       'cnic',
       'phone',
       'emergency_contact',
       'img',
       'role',
       'status',
       'created_at');

       $seachInput= array(
        'id',
        'enrol_id',
       'name',
       'email',
       
       'password',
       'shift_id',
       'join_date',
       'designation_id',
       'department_id',
       'manger_id',
       'first_name',
       'last_name',
       'father_name',
       'dob',
       'cnic',
       'phone',
       'emergency_contact',
       'img',
       'role',
       'status',
       'created_at'
     );

    	   $hiddenColumArray = array('id');

             echo json_encode($this->employeeRepository->getEmployeeDatatable("users", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 

   function editEmployee($id)
   {            
        $tableName = "users";
        $columsarray = array(
        'id',
        'enrol_id',
       'name',
       'email',
       'password',
       'shift_id',
       'working_type',
       'join_date',
       'designation_id',
       'department_id',
       'manger_id',
       'first_name',
       'last_name',
       'father_name',
       'dob',
       'cnic',
       'address',
       'phone',
       'emergency_contact',
       'gross_salary',
       'otherAllowence',
       'img',
       'role',
       'status',
       'created_at'
     );
        $where =array("id"=>$id);
       $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
          return view("editEmployee",["data"=>json_decode(json_encode($data), true)]);    
   }


     
     function updateEmployee(Request $request):JsonResponse 
    {
                    $status= empty($request->status)? 0 : 1;
                  $Name = $request->Name;
                  $Phone = $request->Phone;
                  $shift_id = $request->shift_id;
                  $working_type = $request->working_type;
                  $JoinDate = $request->JoinDate;
                  $designation_id = $request->designation;
                  $department_id = $request->department;
                  $workemail = $request->workemail;
                  $FirstName = $request->FirstName;
                  $LastName = $request->LastName;
                  $FatherName = $request->FatherName;
                  $Password = $request->Password;
                  $Email = $request->Email;
                  $DateOfBirth = $request->DateOfBirth;
                  $CNIC = $request->CNIC;
                  $EmergencyContactNumber = $request->EmergencyContactNumber;
                  $address = $request->address;
                  $OldEmpImage = $request->OldEmpImage;
                  $EnrollNumber = $request->EnrollNumber;
                  $gross_salary = $request->gross_salary;
                  $otherAllowence = $request->otherAllowence;
                  $UserId = $request->UserId;
                $EmpImage= empty($_FILES['input_image_1']['name'])? false    : true;
               $OldEmpImage= empty($_FILES['input_image_1']['name'])? false    : true;

        $filename1 = "";
        if ($EmpImage) {
         $filename1 =     $this->commonRepository->uploadSingleImage($_FILES['input_image_1'],'Users');
        }else{
          $filename1 = str_replace("images/", "", $OldEmpImage);
        }

                  $data = array(
                  'enrol_id'=>$EnrollNumber,
                  'name'=>$Name,
                  'email'=>$workemail,
                  'password'=>Hash::make($Password),
                  'shift_id'=>$shift_id,
                  'working_type'=>$working_type,
                  'join_date'=> $JoinDate,
                  'designation_id'=>$designation_id,
                  'department_id'=>$department_id,
                  'manger_id'=>0,
                  'first_name'=>$FirstName,
                  'last_name'=>$LastName,
                  'father_name'=>$FatherName,
                  'dob'=>$DateOfBirth,
                  'cnic'=>$CNIC,
                  'address'=>$address,
                  'phone'=>$Phone,
                   'img'=>$filename1,
                   'status'=>$status,
                  'emergency_contact'=>$EmergencyContactNumber,
                  'gross_salary'=>$gross_salary,
                  'otherAllowence'=>$otherAllowence

                  );
            $where = array("id"=>$UserId);
        
           return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("users",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

     function detailEmployee($id)
   {            
        $tableName = "users";
        $columsarray = array(
        'id',
        'enrol_id',
       'name',
       'email',
       
       'password',
       'shift_id',
       'working_type',
       'join_date',
       'designation_id',
       'department_id',
       'manger_id',
       'first_name',
       'last_name',
       'father_name',
       'dob',
       'cnic',
       'address',
       'phone',
       'emergency_contact',
       'gross_salary',
       'otherAllowence',
       'img',
       'role',
       'status',
       'created_at'
     );
        $where =array("id"=>$id);
      // $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
      $data1 = $this->employeeRepository->EmployeeDetailByID($id);       
          return view("detailEmployee",["data"=>json_decode(json_encode($data1), true)]);   
            

   }

   function all_designation(Request $request)
   {            
        $tableName = "designations";
        $columsarray = array("des_name","id");
        $where =array();
       $data = $this->commonRepository->selectRows($tableName,$columsarray,$where);
          
           return   $data;   

   }

   function all_department(Request $request)
   {            
        $tableName = "departments";
        $columsarray = array("dept_name","id");
        $where =array();
       $data = $this->commonRepository->selectRows($tableName,$columsarray,$where);
          
          return $data;   

   }

   function deletedEmployee(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("users",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

         function GetEmployeeDetailByEmpId(Request $request)
    {    
          $id = $request->id;
          return  $this->employeeRepository->EmployeeDetailByID($id);
          // User::with('attendance')->find($id)
         
    } 


}
