<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $primaryKey  = "id";
    protected $fillable = [
       'id',
       'name',
       'email',
       'email_verified_at',
       'password',
       'shift_id',
       'join_date',
       'designation_id',
       'department_id',
       'manger_id',
       'first_name',
       'last_name',
       'father_name',
       'dob',
       'cnic',
       'phone',
       'emergency_contact',
       'gross_salary',
       'otherAllowence',
       'img',
       'role'

    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];

    public function payroll()
    {
        return $this->belongsTo(payroll::class);
    }

    

    public function attendance()
    {
        return $this->hasMany('App\Models\attendance','employee_id');
    }

      public function shift()
    {
        return $this->hasMany('App\Models\shift','employee_id');
    } 
    public function leave_apply_emp()
    {
        return $this->hasMany('App\Models\shift','employee_id');
    }

}
