<?php

namespace App\Providers;

use Illuminate\Support\ServiceProvider;
use App\Repositories\Interfaces\commonRepositoriesInterface;
use App\Repositories\Interfaces\employeeRepositoriesInterface;
use App\Repositories\Interfaces\hrRepositoriesInterface;
use App\Repositories\commonRepository;
use App\Repositories\employeeRepository;
use App\Repositories\hrRepository;



class commonRepositoryServiceProvider extends ServiceProvider
{
    /**
     * Register services.
     *
     * @return void
     */
    public function register()
    {
        $this->app->bind(commonRepositoriesInterface::class, commonRepository::class);

         $this->app->bind(employeeRepositoriesInterface::class, employeeRepository::class);
         $this->app->bind(hrRepositoriesInterface::class, hrRepository::class);
  
    }

    /**
     * Bootstrap services.
     *
     * @return void
     */
    public function boot()
    {
        //
    }
}
