<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\Interfaces\commonRepositoriesInterface;
use App\Repositories\Interfaces\hrRepositoriesInterface;
use Illuminate\Support\Facades\DB;
use Session;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Hash;
use GuzzleHttp\Client;
use Carbon\Carbon;
use Laradevsbd\Zkteco\Http\Library\ZktecoLib;
use Excel;
use App\Imports\uploadAttendances;
use App\Models\attendance;
use Illuminate\Support\Collection;
use App\Exports\exportLeaveReport;
use App\Exports\ExportPayrolReport;
use App\Exports\ExportLeaveSummaryReport;
use App\Models\leave_apply_emp;

class HRcontroller extends Controller
{
    private  $hrRepository;
    private  $commonRepository;
    
    public function __construct(hrRepositoriesInterface $hrRepository,commonRepositoriesInterface $commonRepository) 
    {
        $this->hrRepository = $hrRepository;
        $this->commonRepository = $commonRepository;
    }

   function saveShift(Request $request){

      $validator = Validator::make($request->all(), [
           
            'shift_name' => 'required|unique:shifts'
            
            
       ]);

       

        $ShiftData = array(

          'shift_name' =>$request->shift_name

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{ 
             $all_days = array('Monday','Tuesday','Wednesday','Thusday','Friday','Saturday','Sunday');
              $data = $this->commonRepository->InsertRow_GetId("shifts",$ShiftData);
               foreach ($all_days as  $value) {
                 
              $dataDays =  array(
                'shift_id'=>$data,
                'isdayOf'=>0,
                'days'=>$value,
                'startTime'=>'',
                'endTime'=>'',
                'GraceTime'=>'',
                'overTimeStartAfter'=>'',
                'lunchTime'=>'');

                 $this->commonRepository->InsertRow("shift_details",$dataDays);
                 
               }
               
          return response()->json(
            [
                'status'=>TRUE,
                'data' => TRUE

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }


  function GetShiftDetailsByShiftId(Request $request)   ///:JsonResponse
  {
        $tableName1 = "shifts";          $col1 = "id";
        $tableName2 = "shift_details";   $col2 = "shift_id"; 
        $columsarray = array(
'shift_details.id as ShiftDetailsID',
'shift_details.shift_id as shift_id',
'shift_details.isdayOf',
'shift_details.days',
'shift_details.startTime',
'shift_details.endTime',
'shift_details.GraceTime',
'shift_details.overTimeStartAfter',
'shift_details.lunchTime',
'shifts.shift_name'

        );
       
       
        $where =array("$tableName2.shift_id"=>$request->shiftid);
   
    $data =$this->commonRepository->selectRowJoin($tableName1,$tableName2,$col1,$col2,$columsarray,$where);
    return json_decode(json_encode($data), true);
    //    return response()->json(
    //         [
    //             'status'=>TRUE,
    //             'data' => json_decode(json_encode($data), true)

             
    //         ],
    //         Response::HTTP_CREATED
    //     );
     
  }



  function all_shift(Request $request):JsonResponse
  {   
  	    $column = array('id','shift_name');
    
  	      $data = $this->commonRepository->selectRows("shifts",$column,array());
  	      
             return response()->json(
            [
                'status'=>TRUE,
                'data' =>  $data
            ],
            Response::HTTP_CREATED
        );
  }   

  function all_company(Request $request):JsonResponse
  {   
        $column = array('id','comp_name');
    
          $data = $this->commonRepository->selectRows("conpanies",$column,array());
          
             return response()->json(
            [
                'status'=>TRUE,
                'data' =>  $data
            ],
            Response::HTTP_CREATED
        );
  } 


  function UpdateShift(Request $request)   //:JsonResponse
  {     
        foreach($request->d as $value) {
           if (empty(@$value['isdayOf'])) {
                  $isOff = 0;  
              $data = array(
                  
                 'isdayOf' =>$isOff,
                 'shift_id' =>$value['shift_id'], 
                 'days' =>$value['days'],
                 'startTime' =>@$value['startTime'],
                 'endTime' =>@$value['endTime'],
                 'GraceTime' =>@$value['GraceTime'], 
                 'overTimeStartAfter' =>@$value['overTimeStartAfter'],
                 'lunchTime' =>@$value['lunchTime']

                  );

              

             }else{
                $isOff = 1;  
                $data = array(
                  
                 'isdayOf' =>$isOff,
                 'shift_id' =>$value['shift_id'], 
                 'days' =>$value['days'],
                 'startTime' =>'00:00:00',
                 'endTime' =>'00:00:00',
                 'GraceTime' =>'00:00:00', 
                 'overTimeStartAfter' =>'00:00:00',
                 'lunchTime' =>'00:00:00'

                  );
               }
            $where = array("id"=>$value['shift_detail_id']);
          $this->commonRepository->updateRow("shift_details",$data,$where);
          
          }

           return response()->json(
            [
                'status'=>TRUE,
              'data' => true
            ],
            Response::HTTP_CREATED
        );

        return 1;
  }

  
  function shiftDetailDatatable(Request $request){

       $columarray = array(
          'shift_details.id',
          'shifts.shift_name',
          'shift_details.isdayOf',
          'shift_details.days',
          'shift_details.startTime',
          'shift_details.endTime',
          'shift_details.lunchTime',
          'shift_details.GraceTime',
          'shift_details.overTimeStartAfter',
          'shift_details.shift_id'
          
       );

       $seachInput= array(
          'shift_details.id',
          'shifts.shift_name',
          'shift_details.isdayOf',
          'shift_details.days',
          'shift_details.startTime',
          'shift_details.endTime',
          'shift_details.lunchTime',
          'shift_details.GraceTime',
          'shift_details.overTimeStartAfter',
          'shift_details.shift_id'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->getmanagShiftDetailDatatable("shift_details", $request,$columarray,$seachInput,$hiddenColumArray));
  
  }

   function shiftTitleDatatable(Request $request){

       $columarray = array(
          'shifts.id',
          'shifts.shift_name',
          'shifts.added_date'
          
       );

       $seachInput= array(
          'shifts.id',
          'shifts.shift_name',
          'shifts.added_date'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->shiftTitleDatatable("shifts", $request,$columarray,$seachInput,$hiddenColumArray));
  
  }
  
function deletedShift(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("shift_details",$where)
            ],
            Response::HTTP_CREATED
        );  
     }



 function UpdateShiftTitle(Request $request)   //:JsonResponse 
    {     
        $id = $request->editId;
            $name  = $request->txtshiftname;
       
            $data = array(
            'shift_name' =>$name
            );
            $where = array("id"=>$id);
        
           return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("shifts",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

     function deletedShiftTitle(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("shifts",$where)
            ],
            Response::HTTP_CREATED
        );  
     }


   function saveHoliday(Request $request):JsonResponse
   {
       $Name = $request->Name;
       $HolidayRecurTypeId = $request->HolidayRecurTypeId;
       $StartDates = $request->StartDates;
       $DayOfWeek = $request->DayOfWeek;
       $MonthNo = $request->MonthNo;
       $DayofMonth = $request->DayofMonth; 
        if ($StartDates) {
          
       $StartDates = date("Y-m-d",strtotime($request->StartDates));
        }else{
       $StartDates = date("Y-m-d");

        }
      $validator = Validator::make($request->all(), [
            'Name' => 'required',
            'HolidayRecurTypeId' => 'required',
            
       ]);

       

        $HolidayData = array(

         
          'holiday_name'=>$Name,
          'month'=>$MonthNo,
          'day_of_month'=>$DayofMonth,
          'day_of_week'=>$DayOfWeek,
          'recur_type'=>$HolidayRecurTypeId,
          'added_date'=>$StartDates
         

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("holidays",$HolidayData)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }

   
  function HolidayDatatable(Request $request)
  {
       $columarray = array(
          'id',
          'holiday_name',
          'month',
          'day_of_month',
          'day_of_week',
          'recur_type',
          'added_date'
       );

       $seachInput= array(
        'id',
          'holiday_name',
          'month',
          'day_of_month',
          'day_of_week',
          'recur_type',
          'added_date'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->gethrDatatable("holidays", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 

   function editHoliday($id)
   {            
        $tableName = "holidays";
        $columsarray = array(
          'id',
          'holiday_name',
          'month',
          'day_of_month',
          'day_of_week',
          'recur_type',
          'added_date'
     );
        $where =array("id"=>$id);
       $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
          return view("addHoliday",["data"=>json_decode(json_encode($data), true)]);    
   }

   function payroll_sheet_approval($monthYear)
   {            
        
          return view("payroll_sheet_approval",["data"=>$monthYear]);    
   }


 function updateHoliday(Request $request)   //:JsonResponse 
    {     
       if (empty($request->StartDates)) {
            $date  = date("Y-m-d");
       }else{
            $date  =  date("Y-m-d",strtotime($request->StartDates));

       }
   
            $data = array(
            'holiday_name' =>$request->Name,
            'month' =>$request->MonthNo,
            'day_of_month' =>$request->DayofMonth,
            'day_of_week' =>$request->DayOfWeek,
            'recur_type' =>$request->HolidayRecurTypeId,
            'added_date' =>$date

            );
            $where = array("id"=>$request->HolidayEditId);
        
           return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("holidays",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

   function deletedHoliday(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("holidays",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

 //========  Save Leave By Employee 
      function applyLeaveSave(Request $request):JsonResponse
   { 
       $employee_id    = $request->empId;
       $leave_title_id = $request->fkLeaveTypeId;
       $total_leave  = $request->totalLeave;
       $remain_leave = $request->reminingleave;
       $start_date = date("Y-m-d",strtotime($request->StartDate));
       $end_date   = date("Y-m-d",strtotime($request->EndDate));
       $reason     = $request->Reason;
       $status     = empty($request->status)? "0"   : $request->status;
       $added_date     = date("Y-m-d");
        
      $validator = Validator::make($request->all(), [
            'StartDate' => 'required',
            'EndDate' => 'required',
            'Reason' => 'required'
           
            
       ]);

       

        $leaveTitles = array(
            

"employee_id"=>$employee_id,
"leave_title_id"=>$leave_title_id,
"total_leave"=>$total_leave,
"remain_leave"=>$remain_leave,
"start_date"=>$start_date,
"end_date"=>$end_date,
"reason"=>$reason,
"status"=>$status,
"added_date"=>$added_date,
         

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("leave_apply_emps",$leaveTitles)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }

  function applyLeaveDatatable(Request $request)
  {
       $columarray = array(
          'leave_apply_emps.id',
          'leave_apply_emps.employee_id',
          'leave_apply_emps.start_date',
          'leave_apply_emps.end_date',
          'leave_apply_emps.status',
          'leave_apply_emps.added_date',
          'leave_titles.totalLeave',
          'leave_titles.title',
          'users.first_name',
          'users.last_name',
          'users.name',

       );

       $seachInput= array(
          'leave_apply_emps.id',
          'leave_apply_emps.employee_id',
          'leave_apply_emps.start_date',
          'leave_apply_emps.end_date',
          'leave_apply_emps.status',
          'leave_apply_emps.added_date',
          'leave_titles.totalLeave',
          'leave_titles.title',
          'users.first_name',
          'users.last_name',
          'users.name',
          
         
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->getapplyLeaveDatatable("leave_apply_emps", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 

function deletedLeave(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("leave_apply_emps",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

 //========  Save Leave By Employee END 

 //========  Department  
   function saveDepartment(Request $request):JsonResponse
   {
       $Name = $request->dept_name;
       
     
      $validator = Validator::make($request->all(), [
            'dept_name' => 'required|unique:departments',
           
            
       ]);

       

        $leaveTitles = array(

         
          'dept_name'=>$Name,
          // 'added_date'=>date("Y-m-d")
         

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("departments",$leaveTitles)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }
function editDepartment($id)
   {            
        $tableName = "departments";
        $columsarray = array(
          'id',
          'dept_name',
          'added_date'
     );
        $where =array("id"=>$id);
     $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
      return view("addDepartment",["data"=>json_decode(json_encode($data), true)]);    
   }

function updateDepartment(Request $request)   //:JsonResponse 
    {     
   
            $data = array(
            'dept_name' =>$request->dept_name,
            'added_date' =>date("Y-m-d")

            );
            $where = array("id"=>$request->deptEditId);
        
           return response()->json(
            [
                'status'=>TRUE,
                 'data' => $this->commonRepository->updateRow("departments",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

     function departmentDatatable(Request $request)
  {
       $columarray = array(
          'departments.id',
          'departments.dept_name',
          'departments.added_date'
         

       );

       $seachInput= array(
          'departments.id',
          'departments.dept_name',
          'departments.added_date'
         
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->getdepartmentDatatable("departments", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 


   function deletedDepartment(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("departments",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

 //========  Department Employee END 

     //========  Department  
   function savecompany(Request $request):JsonResponse
   {
       $Name = $request->comp_name;
       
     
      $validator = Validator::make($request->all(), [
            'comp_name' => 'required|unique:conpanies',
           
            
       ]);

       

        $leaveTitles = array(

         
          'comp_name'=>$Name,
          'added_date'=>date("Y-m-d")
         

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("conpanies",$leaveTitles)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }
function editcompany($id)
   {            
        $tableName = "conpanies";
        $columsarray = array(
          'id',
          'comp_name',
          'added_date'
     );
        $where =array("id"=>$id);
     $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
      return view("add_company",["data"=>json_decode(json_encode($data), true)]);    
   }

function updateCompany(Request $request)   //:JsonResponse 
    {     
   
            $data = array(
            'comp_name' =>$request->comp_name,
            'added_date' =>date("Y-m-d")

            );
            $where = array("id"=>$request->compEditId);
        
           return response()->json(
            [
                'status'=>TRUE,
                 'data' => $this->commonRepository->updateRow("conpanies",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

     function CompanyDatatable(Request $request)
  {
       $columarray = array(
          'conpanies.id',
          'conpanies.comp_name',
          'conpanies.added_date'
         

       );

       $seachInput= array(
          'conpanies.id',
          'conpanies.comp_name',
          'conpanies.added_date'
         
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->getcompanyDatatable("conpanies", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 


   function deletedCompany(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
            
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("conpanies",$where)
            ],
            Response::HTTP_CREATED
        );  
     }   

 //========  company Employee END 

//========  Designation  
   function saveDesignation(Request $request):JsonResponse
   {
       $Name = $request->des_name;
      $validator = Validator::make($request->all(), [
            'des_name' => 'required|unique:designations',
       ]);

        $leaveTitles = array(
          'des_name'=>$Name,
          // 'added_date'=>date("Y-m-d")
        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("designations",$leaveTitles)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }
function editDesignation($id)
   {            
        $tableName = "designations";
        $columsarray = array(
          'id',
          'des_name',
          'added_date'
     );
        $where =array("id"=>$id);
     $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
      return view("addDesignation",["data"=>json_decode(json_encode($data), true)]);    
   }

function updateDesignation(Request $request)   //:JsonResponse 
    {     
   
            $data = array(
            'des_name' =>$request->des_name,
            'added_date' =>date("Y-m-d")

            );
            $where = array("id"=>$request->desEditId);
        
           return response()->json(
            [
                'status'=>TRUE,
                 'data' => $this->commonRepository->updateRow("designations",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

     function DesignationDatatable(Request $request)
  {
       $columarray = array(
          'designations.id',
          'designations.des_name',
          'designations.added_date'
         

       );

       $seachInput= array(
          'designations.id',
          'designations.des_name',
          'designations.added_date'
         
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->getDesignationDatatable("designations", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 


   function deletedDesignation(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("designations",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

 //========  Designation Employee END 

// ========= LEAVE TITLE
       function saveLeaveTitle(Request $request):JsonResponse
   {
       $Name = $request->title;
       $totalLeave = $request->totalLeave;
      
     
      $validator = Validator::make($request->all(), [
            'title' => 'required|unique:leave_titles',
            'totalLeave' => 'required'
           
            
       ]);

       

        $leaveTitles = array(

         
          'title'=>$Name,
          'totalLeave'=>$totalLeave,
          'added_date'=>date("Y-m-d")
         

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("leave_titles",$leaveTitles)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }



  function leaveTitleDatatable(Request $request)
  {
       $columarray = array(
          'id',
          'title',
          'added_date',
          'totalLeave',
         
       );

       $seachInput= array(
          'id',
          'title',
          'added_date',
          'totalLeave',
         
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->getLeaveTitleDatatable("leave_titles", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 



      function editLeaveTitle($id)
   {            
        $tableName = "leave_titles";
        $columsarray = array(
          'id',
          'title',
          'totalLeave',
          'added_date'
     );
        $where =array("id"=>$id);
     $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
      return view("addLeave",["data"=>json_decode(json_encode($data), true)]);    
   }


 function updateLeaveTitle(Request $request)   //:JsonResponse 
    {     
   
            $data = array(
            'title' =>$request->title,
            'totalLeave' =>$request->totalLeave,
            'added_date' =>date("Y-m-d")

            );
            $where = array("id"=>$request->titleEditId);
        
           return response()->json(
            [
                'status'=>TRUE,
                 'data' => $this->commonRepository->updateRow("leave_titles",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }

     function all_LeaveTitle(Request $request):JsonResponse
  {   
        $column = array('id','title','totalLeave');
    
          $data = $this->commonRepository->selectRows("leave_titles",$column,array());
          
             return response()->json(
            [
                'status'=>TRUE,
                'data' =>  $data
            ],
            Response::HTTP_CREATED
        );
  } 



   function deletedLeaveTitle(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("leave_titles",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

 function Getleavecount_emp(Request $request) ///:JsonResponse
 {
        $empId = $request->empId;
        $leaveid = $request->leaveId;
        $tableName1 = "leave_titles";          $col1 = "id";
        $tableName2 = "leave_apply_emps";   $col2 = "leave_title_id"; 
        $columsarray = array(
       'leave_title_id',
       'total_leave as totalLeave',

       );
       
        $where =array("$tableName2.employee_id"=>$request->empId,"$tableName2.leave_title_id"=>$request->leaveId);
   
    $data =$this->hrRepository->GetTotalLeaveCount_Emp($tableName1,$tableName2,$col1,$col2,$columsarray,$where,$request);
      
        if (count($data) > 0)  {
    return json_decode(json_encode($data), true);  
          }else{

    return json_decode(json_encode(array("leave_title_id"=>$leaveid,"totalLeave"=>10,"countEmpLeave"=>0)), true);  
    
          }

 }
// ========= Employee Leave Count End

 // ======== Today EMployee Attendance 

function todayAttendanceCheck(Request $request) //:JsonResponse
  {     
       
      
//  1 s't parameter is string $ip Device IP Address
//  2 nd  parameter is integer $port Default: 4370

    // $zk = new ZktecoLib(config('192.168.88.220'));

//  or you can use with port
   // $zk = new ZktecoLib(config('192.168.88.220'), 4370);


 //      $zk->connect();

 // $zk->disconnect();

 // $zk->deviceEnable()
  

// ===================================================
   $todayDate =date("Y-m-d",strtotime(date("Y-m-d")));
        return  $this->hrRepository->todayGet_IN_OUT($request->empId,$todayDate);
        
      
      // return   1;
  }

function todayAttendanceDatatable(Request $request)
  {  
       $columarray = array(
    'attendances.id',
    'users.enrol_id',
    'users.name',
    'users.first_name',
    'users.last_name',
    'attendances.employee_id',
    'attendances.date_in',
    'attendances.time_in',
    'attendances.date_out',
    'attendances.time_out',
    'attendances.off',
    'attendances.half_day',
    'attendances.stay_late',
    'attendances.work_less',
    'attendances.hrs_work_with_overtime',
    'attendances.hrs_work_without_overtime',
    'attendances.hrs_late',
    'attendances.hrs_over_time',
    'attendances.status'

       );

       $seachInput= array(
         'attendances.id',
    'users.enrol_id',
    'users.name',
    'users.first_name',
    'users.last_name',
    'attendances.employee_id',
    'attendances.date_in',
    'attendances.time_in',
    'attendances.date_out',
    'attendances.time_out',
    'attendances.off',
    'attendances.half_day',
    'attendances.stay_late',
    'attendances.work_less',
    'attendances.hrs_work_with_overtime',
    'attendances.hrs_work_without_overtime',
    'attendances.hrs_late',
    'attendances.hrs_over_time',
    'attendances.status'

         
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->gettodayAttendanceDatatable("attendances", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 
function todayAttendanceUpdate(Request $request):JsonResponse
{        
 $dateOut = (isset($request->dateOut))? date("Y-m-d",strtotime($request->dateOut)) : date("Y-m-d");
         $data = array(
             "date_out"=>$dateOut,
             "time_out"=>$request->timeOut
            );
          
          $where = array("employee_id"=>$request->empId);
            return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("attendances",$data,$where)
            ],
            Response::HTTP_CREATED
        );
}
function todayattendancesave(Request $request):JsonResponse
   {

    $empId = $request->empId;
    $dateIn= (isset($request->dateIn)) ? date("Y-m-d",strtotime($request->dateIn)):date("Y-m-d");
    $timeIn= (isset($request->timeIn))? (string) $request->timeIn : "00:00:00";
    $dateOut=(isset($request->dateOut))? date("Y-m-d",strtotime($request->dateOut)) : date("Y-m-d");
    $timeOut= (isset($request->timeOut))? (string) $request->timeOut : "00:00:00";
    $hrs_work_with_overtime= (isset($request->hrs_work_with_overtime))? (string) $request->hrs_work_with_overtime    : 0;
    $hrs_work_without_overtime= (isset($request->hrs_work_without_overtime))? (string) $request->hrs_work_without_overtime  : 0;
    $hrs_late= (isset($request->hrs_late))? (string) $request->hrs_late  : 0;
    $hrs_over_time= (isset($request->hrs_over_time))?(string)$request->hrs_over_time :0;

   
    $added_date= date("Y-m-d");
    $status= (isset($request->status))? (string) $request->status : 0;
        

       $todayAttendanceSave = array(

          'employee_id'=>$empId,
          'date_in'=>$dateIn,
          'time_in'=>$timeIn,
          'date_out'=>$dateOut,
          'time_out'=>$timeOut,
          'hrs_work_with_overtime'=>$hrs_work_with_overtime,
          'hrs_work_without_overtime'=>$hrs_work_without_overtime,
          'hrs_late'=>$hrs_late,
          'hrs_over_time'=>$hrs_over_time,
          'added_date'=>$added_date,
          'status'=>$status 
        );
        
       
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("attendances",$todayAttendanceSave)

             
            ],
            Response::HTTP_CREATED
        );

   }

    function deletedAttendance(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("attendances",$where)
            ],
            Response::HTTP_CREATED
        );  
     }

     function resetAttendance(Request $request):JsonResponse  
      {
         $dateOut = (isset($request->dateOut))? date("Y-m-d",strtotime($request->dateOut)) : date("Y-m-d");
         $data = array(
             "time_in"=>'',
             "time_out"=>''
            );
          
           $where = array("id"=>$request->id);
            return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("attendances",$data,$where)
            ],
            Response::HTTP_CREATED
        );

      }
    // =====================PAYROLL  ==================================
     function payrollsave(Request $request):JsonResponse
   {   
      
        $empId = $request->empId;
        $gross_salary = $request->gross_salary;
        $IncomeTax = $request->IncomeTax;
        $ProvidentFund = $request->ProvidentFund;
        $EOBI = $request->EOBI;
        $DayofDeduction = $request->DayofDeduction;
        $late_deduction = $request->late_deduction;
        $TotalDeduction = $request->TotalDeduction;
        $otherAllowence = $request->otherAllowence;
        $net_salary = $request->net_salary;

      $validator = Validator::make($request->all(), [
            'empId' => 'required'
            
            
       ]);

       

        $payrollData = array(

         
          'employee_id' =>$empId,
          'incom_text' =>$IncomeTax,
          'provisional_fund' =>$ProvidentFund,
          'eobi' =>$EOBI,
          'absent_deduction_per_day' =>$DayofDeduction,
          'late_deduction' =>$late_deduction,
          'otherAllowence' =>$otherAllowence,
          'total_deduction' =>$TotalDeduction,
          'gross_salary' =>$gross_salary,
          'net_salary' =>$net_salary,
          'added_date'=>date("Y-m-d"),
          'status' => 0
         

        );
        
       if ($validator->fails()) {
             return response()->json(
            [
                'status'=>FALSE,
                'data' => $validator->messages()->first()
            ],
            Response::HTTP_CREATED

            );
           
       }else{
          
          return response()->json(
            [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("payrolls",$payrollData)

             
            ],
            Response::HTTP_CREATED
        );

       
       }

        
   }

    function total_absent_Without_leave_end_holiday(Request $request){
               $id = $request->id;
        return $this->hrRepository->total_absent_Without_leave_end_holiday($id);
     }
     function total_late(Request $request){
               $id = $request->id;
        return $this->hrRepository->total_late($id);
     }

    function editPayroll($id)
   {             
      $data = $this->hrRepository->GetPayrollEmp($id);    
      return view("payroll",["data"=>json_decode(json_encode($data), true)]);    
   }

 function UpdatePayroll(Request $request)   //:JsonResponse 
    {     
       
   
        $empId = $request->empId;
        $gross_salary = $request->gross_salary;
        $IncomeTax = $request->IncomeTax;
        $ProvidentFund = $request->ProvidentFund;
        $EOBI = $request->EOBI;
        $DayofDeduction = $request->DayofDeduction;
        $late_deduction = $request->late_deduction;
        $TotalDeduction = $request->TotalDeduction;
        $otherAllowence = $request->otherAllowence;
        $net_salary = $request->net_salary;
        $data = array(

         
          'employee_id' =>$empId,
          'incom_text' =>$IncomeTax,
          'provisional_fund' =>$ProvidentFund,
          'eobi' =>$EOBI,
          'otherAllowence' =>$otherAllowence,
          'absent_deduction_per_day' =>$DayofDeduction,
          'late_deduction' =>$late_deduction,
          'total_deduction' =>$TotalDeduction,
          'gross_salary' =>$gross_salary,
          'net_salary' =>$net_salary,
          'added_date'=>date("Y-m-d"),
          'status' => 0
         

        );

        
            $where = array("id"=>$request->editId);
        
           return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("payrolls",$data,$where)
            ],
            Response::HTTP_CREATED
        );

     }
    // =====================PAYROLL  END===============================
    
    function payrollDatatable(Request $request)
  {
       $columarray = array(
          'payrolls.id',
          'payrolls.gross_salary',
          'payrolls.net_salary',
          'payrolls.added_date',
          'users.first_name',
          'users.last_name',
          'users.name'
       );

       $seachInput= array(
          'payrolls.id',
          'payrolls.gross_salary',
          'payrolls.net_salary',
          'payrolls.added_date',
          'users.first_name',
          'users.last_name',
          'users.name'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->payrollDatatable("payrolls", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 


   function deletePayroll(Request $request):JsonResponse  
      {

         $id  = $request->id;
         $where = array("id"=>$id);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("payrolls",$where)
            ],
            Response::HTTP_CREATED
        );  
     }
  
    // ======================MAKE Salary 
     function saveMakePayment(Request $request){

             $payrollId = $request->payrollId;
             $employee_id = $request->employee_id;
             $payroleDate = $request->payroleDate;
             $makename = $request->makename;
             $makegross = $request->makegross;
             $makeleave = $request->makeleave;
             $makeabsent = $request->makeabsent;
             $makemhour = $request->makemhour;
             $makehour = $request->makehour;
             $makeabsentded = $request->makeabsentded;
             $maketded = $request->maketded;
             $other_allowance = $request->other_allowance;
             $makenet = $request->makenet;
             $makeamount = $request->makeamount;
             $paymentmode = $request->paymentmode;
             $chqno = $request->chqno;
              $payment =  array(

                  'payroll_id'=>$payrollId,
                  'employee_id'=>$employee_id,
                  'total_deduction'=>$maketded,
                  'gross_salary'=>$makegross,
                  'net_salary'=>$makenet,
                  'paymentmode'=>$paymentmode,
                  'chkno'=>$chqno,
                  'payroleDate'=>$payroleDate,
                  'added_date'=>date("Y-m-d"),
                  'status'=> 1 


              );
               

               $data =   $this->commonRepository->InsertRow_GetId("make_payments",$payment);
                  
              if (!empty($data)) {
                  $data = array(
                  "status"=>1
                 
                  );
                  $where = array("employee_id"=>$employee_id,"id"=>$payrollId);
                 
                 return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("payrolls",$data,$where)
            ],
            Response::HTTP_CREATED
          );
              }
         
     }
      function makepaymentDatatable(Request $request)
   {            
         
       $columarray = array(
          'payrolls.id',
          'payrolls.gross_salary',
          'payrolls.total_deduction',
          'payrolls.net_salary',
          'payrolls.added_date',
          'payrolls.status',
          'users.enrol_id',
          'users.first_name',
          'users.last_name',
          'users.name'
       );

       $seachInput= array(
          'payrolls.id',
          'payrolls.gross_salary',
          'payrolls.total_deduction',
          'payrolls.net_salary',
          'payrolls.added_date',
          'payrolls.status',
          'users.enrol_id',
          'users.first_name',
          'users.last_name',
          'users.name'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->makepaymentDatatable("payrolls",$request,$columarray,$seachInput,$hiddenColumArray));
          
   }  
function makepaymentDatatable_facon(Request $request)
   {            
         
       $columarray = array(
          'payrolls.id',
          'payrolls.gross_salary',
          'payrolls.total_deduction',
          'payrolls.net_salary',
          'payrolls.added_date',
          'payrolls.status',
          'users.enrol_id',
          'users.first_name',
          'users.last_name',
          'users.name'
       );

       $seachInput= array(
          'payrolls.id',
          'payrolls.gross_salary',
          'payrolls.total_deduction',
          'payrolls.net_salary',
          'payrolls.added_date',
          'payrolls.status',
          'users.enrol_id',
          'users.first_name',
          'users.last_name',
          'users.name'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->makepaymentDatatable_facon("users.",$request,$columarray,$seachInput,$hiddenColumArray));
          
   }

   function payroll_approved_OR_not_approved(Request $request)
   {            
         
       $columarray = array(

'payroll_data_approval.id',
'payroll_data_approval.emp_enroll',
'payroll_data_approval.emp_name',
'payroll_data_approval.department',
'payroll_data_approval.salary_package',
'payroll_data_approval.gross_salary',
'payroll_data_approval.lates',
'payroll_data_approval.late_deduct',
'payroll_data_approval.late_deduct_amt',
'payroll_data_approval.half_day',
'payroll_data_approval.half_day_deduct',
'payroll_data_approval.half_day_deduct_amt',
'payroll_data_approval.absent',
'payroll_data_approval.absent_deduct',
'payroll_data_approval.loan',
'payroll_data_approval.total_deduction',
'payroll_data_approval.bonus_extra_allowance',
'payroll_data_approval.fuel_allowance',
'payroll_data_approval.net_salary',
'payroll_data_approval.sl',
'payroll_data_approval.cl',
'payroll_data_approval.hd',
'payroll_data_approval.yearMonth',
'payroll_data_approval.dateTime',
'payroll_data_approval.status'
       );

       $seachInput= array(
         
'payroll_data_approval.id',
'payroll_data_approval.emp_enroll',
'payroll_data_approval.emp_name',
'payroll_data_approval.department',
'payroll_data_approval.salary_package',
'payroll_data_approval.gross_salary',
'payroll_data_approval.lates',
'payroll_data_approval.late_deduct',
'payroll_data_approval.late_deduct_amt',
'payroll_data_approval.half_day',
'payroll_data_approval.half_day_deduct',
'payroll_data_approval.half_day_deduct_amt',
'payroll_data_approval.absent',
'payroll_data_approval.absent_deduct',
'payroll_data_approval.loan',
'payroll_data_approval.total_deduction',
'payroll_data_approval.bonus_extra_allowance',
'payroll_data_approval.fuel_allowance',
'payroll_data_approval.net_salary',
'payroll_data_approval.sl',
'payroll_data_approval.cl',
'payroll_data_approval.hd',
'payroll_data_approval.yearMonth',
'payroll_data_approval.dateTime',
'payroll_data_approval.status'
     );

   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->payroll_approved_OR_not_approved("payroll_data_approval",$request,$columarray,$seachInput,$hiddenColumArray));
          
   }


     function makepaymentDetail(Request $request){
           $id = $request->id;
           $data = $this->hrRepository->GetPayrollEmp($id);
          
          return  $data;  
     }
    // =====================MAKE Salary End
  function UploadAttendance_advance(Request $request)
    { 
      $request->validate([
        'file' => 'required', // Validate the file type
    ]);

        // $data = Excel::import(new uploadAttendances,$request->file('file'),'', \Maatwebsite\Excel\Excel::XLSX);
        // $data = Excel::toCollection(new uploadAttendances,$request->file('file'),'', \Maatwebsite\Excel\Excel::XLSX);
    if ($request->hasFile('file')) {
        $file = $request->file('file');
        $data = Excel::toArray(new uploadAttendances,$request->file('file'),'', \Maatwebsite\Excel\Excel::XLSX);
           $attData =[];
           foreach ($data[0] as  $value) {
            if (!empty($value['ac_no'])) {
            
              $columsarray = array('id' );
              $where =array(
                "employee_id"=>$value['ac_no'],
                "date_in"=>date("Y-m-d",strtotime($value['date'])),
                "date_out"=>date("Y-m-d",strtotime($value['date']))
            );
       $chek = attendance::where("employee_id",$value['ac_no'])->whereDate("date_in",date("Y-m-d",strtotime($value['date'])))->whereDate("date_out",date("Y-m-d",strtotime($value['date'])))->count();
            if ($chek <= 0  ) {
              
              //    $attData[] =  array(
              //   'employee_id' => $value['ac_no'],
              //   'time_in' => $value['clock_in'],
              //   'time_out' => $value['clock_out'],
              //   'date_in' => date("Y-m-d",strtotime($value['date'])),
              //   'date_out' => date("Y-m-d",strtotime($value['date'])),
              //   'hrs_work_with_overtime' => "0",
              //   'hrs_work_without_overtime' => "0",
              //   'hrs_late' => "0",
              //   'hrs_over_time' => "0",
              //   'added_date' =>  date("Y-m-d"),

              //   'status' => 1

              // );
                
               
              // ========================checking attendance

              $class = "";
              $date_in_td = date("Y-m-d",strtotime($value['date']));
              $date_out_td = date("Y-m-d",strtotime($value['date']));
              $off_td = 0;  //$value['off'];
              $hrs_late_td = 0; // $value['hrs_late'];
              $stay_late_td = 0; // $value['stay_late'];
              $half_day_td = 0; //$value['half_day'];
              $work_less_td =0; // $value['work_less'];
              $time_in_td = $value['clock_in'];
              $time_out_td = $value['clock_out'];  
            
           $ShiftByAction = $this->hrRepository->ShiftByAction($value['clock_in'],$value['clock_out'],$empId,date("Y-m-d",strtotime($value['date'])));
           
            if($this->hrRepository->LeaveCheckAttendance(date("Y-m-d",strtotime($value['date'])),$value['ac_no']))
             {
              $class = "leaves";
              $off_td = "leaves";
              $hrs_late_td = "leaves";
              $stay_late_td = "leaves";
              $half_day_td = "leaves";
              $work_less_td = "leaves";
              $time_in_td = "leaves";
              $time_out_td= "leaves"; 
             }
           else if($this->hrRepository->isHoliday(date("Y-m-d",strtotime($value['date'])))) {
              $class = "Company_holiday";
              $off_td = "Company Holiday";
              $hrs_late_td = "Company Holiday";
              $stay_late_td = "Company Holiday";
              $half_day_td = "Company Holiday";
              $work_less_td = "Company Holiday";
              $time_in_td = "Company Holiday";
              $time_out_td= "Company Holiday"; 
             }
             else if($value['clock_in'] == "" &&  $value['clock_out'] == "")
             {
                $days = date("l",strtotime($value['date']));
                if($days != "Sunday" || $days != "Saturday" ) {
                $class = $days;  
                $off_td = 1;
                $hrs_late_td = $days;
                $stay_late_td = $days;
                $half_day_td = $days;
                $work_less_td = $days;
                $time_in_td = $days;
                $time_out_td= $days;    
                }
               
             } 
             else if($ShiftByAction['status'] == "late")
                 {
                  $hrs_late_td = 1;   
                  $class = "late";   
                 $work_less_td = $ShiftByAction['work_less'];   
          
                 }
            
                else if($ShiftByAction['status'] == "stay_late")
                {
                $stay_late_td = $ShiftByAction['stay_late'];   
                $class = "stay_late";   
                }
             
                 
              $date_in   ="<span class='".$class."'>".$date_in_td."</span>";
              $date_out  ="<span class='".$class."'>".$date_out_td."</span>";
              $off       = "<span class='".$class."'>".$off_td."</span>";
              $hrs_late  ="<span class='".$class."'>".$hrs_late_td."</span>";
              $stay_late = "<span class='".$class."'>".$stay_late_td."</span>";
              $half_day  = "<span class='".$class."'>".$half_day_td."</span>";
              $work_less = "<span class='".$class."'>".$work_less_td."</span>";
              $time_in   = "<span class='".$class."'>".$time_in_td."</span>";
              $time_out  = "<span class='".$class."'>".$time_out_td."</span>";
              
                 $attData[] =  array(
                'employee_id' => $value['ac_no'],
                'time_in' => $value['clock_in'],
                'time_out' => $value['clock_out'],
                'date_in' => date("Y-m-d",strtotime($value['date'])),
                'date_out' => date("Y-m-d",strtotime($value['date'])),
                'hrs_work_with_overtime' => "0",
                'hrs_work_without_overtime' => "0",
                'hrs_late' => "0",
                'hrs_over_time' => "0",
                'added_date' =>  date("Y-m-d"),

                'status' => 1

              );

              // ==========================checking attendance End
               }
               // else
               // {
               //      return response()->json(
               //      [
               //      'status'=>FALSE,
               //      'data' => "Data is already In"
               //      ],
               //      Response::HTTP_CREATED
               //      );

               // }
              }  
             }  
        
                return response()->json(
                [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("attendances",$attData)
                ],
                Response::HTTP_CREATED
                );

           
  
          }

  }

   function UploadAttendance(Request $request)
    { 
      $request->validate([
        'file' => 'required', // Validate the file type
    ]);

        // $data = Excel::import(new uploadAttendances,$request->file('file'),'', \Maatwebsite\Excel\Excel::XLSX);
        // $data = Excel::toCollection(new uploadAttendances,$request->file('file'),'', \Maatwebsite\Excel\Excel::XLSX);
    if ($request->hasFile('file')) {
        $file = $request->file('file');
        $data = Excel::toArray(new uploadAttendances,$request->file('file'),'', \Maatwebsite\Excel\Excel::XLSX);
           $attData =[];
           foreach ($data[0] as  $value) {
            if (!empty($value['ac_no'])) {
            
              $columsarray = array('id' );
              $where =array(
                "employee_id"=>$value['ac_no'],
                "date_in"=>date("Y-m-d",strtotime($value['date'])),
                "date_out"=>date("Y-m-d",strtotime($value['date']))
            );
       $chek = attendance::where("employee_id",$value['ac_no'])->whereDate("date_in",date("Y-m-d",strtotime($value['date'])))->whereDate("date_out",date("Y-m-d",strtotime($value['date'])))->count();
            if ($chek <= 0  ) {
              
                 $attData[] =  array(
                'employee_id' => $value['ac_no'],
                'time_in' => $value['clock_in'],
                'time_out' => $value['clock_out'],
                'date_in' => date("Y-m-d",strtotime($value['date'])),
                'date_out' => date("Y-m-d",strtotime($value['date'])),
                'hrs_work_with_overtime' => "0",
                'hrs_work_without_overtime' => "0",
                'hrs_late' => "0",
                'hrs_over_time' => "0",
                'added_date' =>  date("Y-m-d"),
                'branch' => $value['department'],

                'status' => 1

              );
                 // ;
               
              
           
               }
               else
               {
                    return response()->json(
                    [
                    'status'=>FALSE,
                    'data' => "Data is already In"
                    ],
                    Response::HTTP_CREATED
                    );

               }
              }  
             }  
        
                return response()->json(
                [
                'status'=>TRUE,
                'data' => $this->commonRepository->InsertRow("attendances",$attData)
                ],
                Response::HTTP_CREATED
                );

           
  
          }

  }

   function editAttendance($id){
        $tableName = "attendances";
        $columsarray = array(
        'id',
        'employee_id',
        'date_in',
        'time_in',
        'date_out',
        'time_out',
        'hrs_work_with_overtime',
        'hrs_work_without_overtime',
        'hrs_late',
        'hrs_over_time',
        'status',
        'added_date'  
        );

        $where =array("id"=>$id);
       $data = $this->commonRepository->selectRow($tableName,$columsarray,$where);
          
          return view("editAttendance",["data"=>json_decode(json_encode($data), true)]);
   }

   function single_attendance($id,$r,$date){
       
       // return $id;
       // return $r;
    $data  = array("id"=>$id,"r"=>$r,"date"=>$date);
    return view("add_attendance",["data"=>json_decode(json_encode($data), true)]);
   }

function updateAttend(Request $request){

         $data = array(
             "time_in"=>$request->timeIn,
             "time_out"=>$request->timeOut,
             "status"=>$request->status
            );

          $where = array("id"=>$request->editId);
            return response()->json(
            [
                'status'=>TRUE,
              'data' => $this->commonRepository->updateRow("attendances",$data,$where)
            ],
            Response::HTTP_CREATED
        );

   }


  function bulkDeleteAttendance(Request $request)
  {
           $ids = explode(",",$request->selectedIDs);
          
           foreach ($ids  AS  $value) {
                
         $where = array("id"=>$value);
         $this->commonRepository->deleteRow("attendances",$where);
           }
            return response()->json(
            [
                'status' =>TRUE,
                'data'   => true
            ],
            Response::HTTP_CREATED
        );  
      
        
  }

  function getLeaveReportssss(Request $request)
  {
     $enrol_id = $request->empId;
    $start_date = date("Y-m-d",strtotime($request->start_date));
    $end_date = date("Y-m-d",strtotime($request->end_date));

    // Create an array with the required data
    $data = [
        'enrol_id' => $enrol_id,
        'start_date' => $start_date,
        'end_date' => $end_date,
    ];  
   
    // Pass the array to ExportLeaveReport
    return Excel::download(new exportLeaveReport($data), 'leave_Report.xlsx');
      // Export leave report data to a temporary file
       
  
         // return DB::select("SELECT * FROM leave_apply_emps WHERE   DATE_FORMAT(start_date, '%Y-%m-%d') >= '$start_date' AND DATE_FORMAT(end_date, '%Y-%m-%d') <= '$end_date'  ");

  }

function getExportLeaveSummaryReport(Request $request)
  {
     $enrol_id = $request->empId;
    $start_date = date("Y-m-d",strtotime($request->start_date));
    $end_date = date("Y-m-d",strtotime($request->end_date));

    // Create an array with the required data
    $data = [
        'enrol_id' => $enrol_id,
        'start_date' => $start_date,
        'end_date' => $end_date,
    ];  
   
    // Pass the array to ExportLeaveReport
    return Excel::download(new ExportLeaveSummaryReport($data), 'LeaveSummaryReport.xlsx');
      // Export leave report data to a temporary file
       
  
         // return DB::select("SELECT * FROM leave_apply_emps WHERE   DATE_FORMAT(start_date, '%Y-%m-%d') >= '$start_date' AND DATE_FORMAT(end_date, '%Y-%m-%d') <= '$end_date'  ");
  }



  function payrollDataSaleemSir(Request $request)
  {

       $monthYear = explode("/",$request->monthYear);
          $monthYear[0]; ////month
          $monthYear[1]; ////Year
      $real_YearMonth = $monthYear[0]."-".$monthYear[1]; 
      $insert_payroll_approval_data = array();
    foreach($request['tableData'] as $value) {
    // $value['column_1'];// => #
           
   $insert_payroll_approval_data[] = array(
    'emp_enroll' => $value['column_3'],// => emp_enroll
    'emp_name' => $value['column_4'],// => emp_name
    'department' => $value['column_5'], //=> department
    'salary_package' => $value['column_6'], //=> salary package
    'gross_salary' => $value['column_7'], ///=> gross salary
    'lates' =>  $value['column_8'],// => late
    'late_deduct' =>  $value['column_9'],// => late deduction
    'late_deduct_amt' =>  $value['column_10'],// => late deduction amt
    'half_day' =>   $value['column_11'],// => HD
    'half_day_deduct' =>   $value['column_12'],// => HD deductuion 
    'half_day_deduct_amt' =>   $value['column_13'],// => HD deductuion amount
    'absent' =>   $value['column_14'],// => absent
    'absent_deduct' =>   $value['column_15'],// => absent deduction
    'loan' => $value['column_16'],// => loan
    'total_deduction' => $value['column_17'],// => total Deduction
    'bonus_extra_allowance' => $value['column_18'],// => bonus extra allaowns
    'fuel_allowance' => $value['column_19'],// => fuel Allownce
    'net_salary' => $value['column_20'],// => Net Salary
    'sl' => $value['column_21'],// => SL
    'cl' => $value['column_22'],// => CL
    'hd' => $value['column_23'],// => HD  
    'yearMonth' => $real_YearMonth,// => HD  
    'dateTime' => date("Y-m-d"),// => HD      
    'status' => 0    // => HD  
    );
           

      
    
    }       
   
          
          $where = array(
            'yearMonth'=> $real_YearMonth,
            'status'=>0,
            
        );
          
          // if($this->commonRepository->deleteRow("payroll_data_approval",$where)) {
                $this->commonRepository->deleteRow("payroll_data_approval",$where);
                $this->commonRepository->InsertRow("payroll_data_approval",$insert_payroll_approval_data); 
                 return 1;  
  // }
  }


  function approvedBulk(Request $request)
  {
      $ids =explode(",",$request->selectedIDs);
    foreach($ids as $value) 
    {
          $data = array(
            'status' =>1
          ); 
          $where = array("id"=>$value);
          $this->commonRepository->updateRow("payroll_data_approval",$data,$where);
         
    }       
   
                 return 1;  
  
  }

 function notapprovedBulk(Request $request)
  {

    $ids =explode(",",$request->selectedIDs);
    foreach($ids as $value) 
    {
          $data = array(
            'status' =>1
          ); 
          $where = array("id"=>$value);
          $this->commonRepository->updateRow("payroll_data_approval",$data,$where);
         
    }       
   
                 return 1;  
  
  }

 function payrollApprovalDatatable(Request $request)
  {
       $columarray = array(
          
        'payroll_data_approval.id',
        'payroll_data_approval.yearMonth',
        'payroll_data_approval.dateTime',
        'payroll_data_approval.status'
       );

       $seachInput= array(
         
        'payroll_data_approval.id',
        'payroll_data_approval.yearMonth',
        'payroll_data_approval.dateTime',
        'payroll_data_approval.status'
     );
  
   $hiddenColumArray = array('id');

     echo json_encode($this->hrRepository->payroll_approval_Datatable("payroll_data_approval", $request,$columarray,$seachInput,$hiddenColumArray));
      

    
  } 

 function deletedPayrollapproval(Request $request):JsonResponse  
      {

         $monthyear  = $request->monthyear;
         $where = array("yearMonth"=>$monthyear);
         
            return response()->json(
            [
                'status' =>TRUE,
                'data'   =>$this->commonRepository->deleteRow("payroll_data_approval",$where)
            ],
            Response::HTTP_CREATED
        );  
     }
  
    function getPayrollReport(Request $request)
  {
     $enrol_id = $request->empId;
    $monthYear= explode("/",$request->monthyear);
$monthYear[0];  ///month
$monthYear[1];  ////Year
  
    $data = [
        'month' => $monthYear[0],
        'year' => $monthYear[1],
        'enrol_id' => $enrol_id,
    ];  
   
    // Pass the array to ExportLeaveReport
    return Excel::download(new ExportPayrolReport($data), 'pyarol_reports.xlsx');
      // Export leave report data to a temporary file
       
  
         // return DB::select("SELECT * FROM leave_apply_emps WHERE   DATE_FORMAT(start_date, '%Y-%m-%d') >= '$start_date' AND DATE_FORMAT(end_date, '%Y-%m-%d') <= '$end_date'  ");
    
  }

}//class end

  