<?php
namespace App\Repositories;

use Closure;
use App\Repositories\Interfaces\employeeRepositoriesInterface;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\attendance;
use Illuminate\Support\Facades\URL;
use Illuminate\Support\Facades\Hash;
use Auth;      

class employeeRepository implements employeeRepositoriesInterface
{
     function today_total_Employee_absent_present()
     {     
          $starting_date = date("Y-m-d");
          $ending_date = date("Y-m-d");
$total_present = DB::select("SELECT COUNT(id) as cnt FROM users  where status = 1 and role = 'employee' AND id IN (SELECT employee_id FROM attendances WHERE DATE_FORMAT(date_in, '%Y-%m-%d') >= '$starting_date' AND DATE_FORMAT(date_in, '%Y-%m-%d') <= '$ending_date' )");
           
           $total_absent = DB::select("SELECT COUNT(id) as cnt  FROM users WHERE id NOT IN  (SELECT id   FROM users  where status = 1 and role = 'employee' AND id IN (SELECT employee_id FROM attendances  WHERE   DATE_FORMAT(date_in, '%Y-%m-%d') >= '$starting_date' AND DATE_FORMAT(date_in, '%Y-%m-%d') <= '$ending_date' ))AND role = 'employee'");

         $total_emp  = User::where('role','employee')->count();
         $total_present  = json_decode(json_encode($total_present[0]), true);
         $total_absent  = json_decode(json_encode($total_absent[0]), true);
         return array("total_emp"=>$total_emp,"total_present"=>$total_present['cnt'] ,"total_absent"=>$total_absent['cnt']);
     }
     function EmployeeDetailByID($id){
                  
                  $setting  = User::select(
'users.id as uid',
'users.name',
'users.enrol_id',
'users.email' ,
'users.password',
'users.shift_id' ,
'users.join_date' ,
'users.designation_id' ,
'users.department_id' ,
'users.manger_id' ,
'users.first_name',
'users.last_name' ,
'users.father_name',
'users.dob',
'users.cnic' ,
'users.phone' ,
'users.gross_salary' ,
'users.otherAllowence' ,
'users.branch' ,
'users.emergency_contact',
'users.img' ,
'users.role',
'users.status',
'users.address',
'departments.id as dept_id',
'departments.dept_name',
'designations.id as des_id',
'designations.des_name');
                  $setting->join("departments","departments.id","users.department_id"); 
                  $setting->join("designations","designations.id","users.designation_id"); 
                  $setting->where("users.enrol_id",$id); 
            return  $setting->get(); 

           
            
     }


    function getEmployeeDatatable($tableName,$request, array $columsarray,array $seachInput,array $hiddenColumArray){

              
         

        $search = ( isset($request->search) ) ? ($request->search['value']) : null;      
        $start  = ( isset($request->start) )  ? $request->start             : 0;
        $length = ( isset($request->length) ) ? $request->length            : 10;
        $draw   = ( isset($request->draw) )   ? (int) $request->draw        : null;
        /* Ordering */
        $s_col = "";
        $sort = "";
        if ( isset( $_GET['order'] ) )
        {
        $s_col = "";
        if ( $_GET['columns'][0]['orderable'] == "true" )
        {
        $s_col = $columsarray[ intval( $_GET['order'][0]['column'] ) ];
        $sort = $_GET['order'][0]['dir'];
        }

        }else{
        $s_col = $columsarray[0];
        $sort = 'desc';
        }

  // echo "'".$s_col."','".$sort."'";

        #### Search Query #####
        if($search) {
            $ml = "";
            $mlx = "";

   

                $listing = DB::table($tableName);
                $listing->select($columsarray);
                
         foreach ($seachInput as $mkey => $mval) {
        
           
        
         $listing->orWhere($mval,'like', '%' . $search . '%');
        
         }
      
                $recordsTotal  = $listing->count();
                        $listing->skip($start)->take($length)->orderBy($s_col,$sort);
                        $data = $listing->get();
             
              
              
               
             } else 
            { 

              $listing = DB::table($tableName);
              $listing->select($columsarray);
              $recordsTotal  = $listing->count();
              $listing->skip($start)->take($length)->orderBy($s_col,$sort);
              $data = $listing->get();
       

            }

         $data = json_decode(json_encode($data), true);
         $columns = array();
        if($draw == 1){ $draw - 1; }

        $columns["draw"] =$draw+1;
        $columns["recordsTotal"] = $recordsTotal; //total record,
        $columns["recordsFiltered"] = $recordsTotal; //filter record, same as total record, then next button will appear

        $i = $start;

        foreach($data as $key => $val){
            $i++;
          
            
           
            $id = $val['id'];
            $name= $val['name'];
            $enrol_id= $val['enrol_id'];
            
            $status  = $val['status'];
            $created_at  = $val['created_at'];
            if ($status == 1) {

                   $status = "<div class='mb-2 mr-2 badge badge-pill badge-success'>active</div>";

               }

               else{

                $status = "<div class='mb-2 mr-2 badge badge-pill badge-danger'>Deactive</div>";

               }  
            $uniq = ( isset($_GET['uniq']) ) ? $_GET['uniq'] : 'no-uniq';
        
            $action = '<a style="color:#000" href="editEmployee/'.$id.'">Edit</a> | 
          <a style="color:#000" href="detailEmployee/'.$enrol_id.'">View</a> | 
          <a style="color:#000" href="#" onclick="deleted('.$id.')" >Delete</a>';
           

            //6 columns
            $columns["data"][$key] = array(
                 ##### disabling this for the time being needs work "{$first_column}",

            $enrol_id,
            $name,
            
            $status,
 
        

            $action
            );
        }
        if($recordsTotal =='0'){
            $columns["data"] = array();
        }
        //Jason Encode
        // echo json_encode( $columns );
        return $columns;


    
       


    }
}  //class tag end




?>