<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('users', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('email')->unique();
            $table->string('enrol_id')->nullable();
            $table->string('address')->nullable();
            $table->string('password')->nullable();
            $table->integer('company_id')->nullable();
            $table->integer('shift_id')->nullable();
               $table->enum('working_type', ['byfixedhours', 'byfixedtime'])->default('byfixedhours');
            $table->dateTime('join_date')->nullable();
            $table->integer('designation_id')->nullable();
            $table->integer('department_id')->nullable();
            $table->integer('manger_id')->nullable();
            $table->integer('gross_salary')->nullable();
            $table->integer('otherAllowence')->nullable();
            $table->string('first_name')->nullable();
            $table->string('last_name')->nullable();
            $table->string('father_name')->nullable();
            $table->dateTime('dob')->nullable();
            $table->string('cnic')->nullable();
            $table->string('phone')->nullable();
            $table->string('emergency_contact')->nullable();
            $table->string('img')->nullable();
            $table->string('role')->nullable();
            $table->enum('branch', ['facon_is', 'facon_ls'])->default('facon_is');
            $table->string('status')->nullable();
            $table->rememberToken();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('users');
    }
};
