<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('attendances', function (Blueprint $table) {
            $table->id();
            $table->integer('employee_id')->nullable();
            $table->integer('shift_id')->nullable();
            $table->dateTime('date_in')->date();
            $table->string('time_in')->nullable();
            $table->dateTime('date_out')->date();
            $table->string('time_out')->nullable();
            $table->string('hrs_work_with_overtime')->nullable();
            $table->string('hrs_work_without_overtime')->nullable();
            $table->string('hrs_over_time')->nullable();
            $table->string('off')->nullable();
            $table->string('hrs_late')->nullable();
            $table->string('stay_late')->nullable();
            $table->string('half_day')->nullable();
            $table->string('work_less')->nullable();
            $table->enum('branch', ['facon_is', 'facon_ls'])->default('facon_is');
            $table->dateTime('added_date')->time();
            $table->integer('status')->nullable();
           

        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('attendances');
    }
};
