<?php

use App\Http\Controllers\ProfileController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\HRcontroller;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

// Route::get('/dashboard', function () {
//     return view('dashboard');
// })->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
  Route::get("dashboard",[EmployeeController::class,'dashboard']);
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
   
    // Route::view('makesalary','make_salary');
    Route::view('makesalary_normal','make_salary');
    Route::view('makesalary','make_salary_payment');
    Route::view('manage_payroll_sheet_approval','manage_payroll_sheet_approval');
    Route::view('payrolReport','payrollReport');
    Route::view('payslip','payslip');
    Route::view('leaveReport','leaveReport');   
    Route::view('leavesummary','leavesummaryreports');
    Route::view('applyLeave','applyLeave');
    Route::view('upload_attendance','upload_attendance');
    Route::view('add_attendance','add_attendance');
    Route::view('add_view_emp_leave','add_view_emp_leave');
    Route::view('addLeave','addLeave');
    Route::view('addDepartment','addDepartment');
    Route::view('add_company','add_company');
    Route::view('addDesignation','addDesignation');
    Route::view('managLeave','managLeave');
    Route::view('addHoliday','addHoliday');
    Route::view('addShift','addShift');
    Route::view('addEmployee','addEmployee');
    Route::view('payroll','payroll');
    Route::view('managEmployee','managEmployee');
    Route::view('manageCompany','manageCompany');
    Route::view('managPayroll','managPayroll');
    Route::view('managHoliday','managHoliday');
    Route::view('managDepartment','managDepartment');
    Route::view('managDesignation','managDesignation');
    Route::view('managShiftDetail','managShiftDetail');

Route::get("editEmployee/{id}",[EmployeeController::class,'editEmployee']);
// Route::get("detailEmployee/{id}/{branch}",[EmployeeController::class,'detailEmployee']);
Route::get("detailEmployee/{id}",[EmployeeController::class,'detailEmployee']);
Route::get("editHoliday/{id}",[HRcontroller::class,'editHoliday']);
Route::get("editLeaveTitle/{id}",[HRcontroller::class,'editLeaveTitle']);
Route::get("editcompany/{id}",[HRcontroller::class,'editcompany']);
Route::get("editDepartment/{id}",[HRcontroller::class,'editDepartment']);
Route::get("editDesignation/{id}",[HRcontroller::class,'editDesignation']);
Route::get("editPayroll/{id}",[HRcontroller::class,'editPayroll']);
Route::get("editAttendance/{id}",[HRcontroller::class,'editAttendance']);
Route::get('add_attendance/{id}/{r}/{date}',[HRcontroller::class,'single_attendance']);
Route::get("payroll_sheet_approval/{id}",[HRcontroller::class,'payroll_sheet_approval']);
});

require __DIR__.'/auth.php';
